/* WZP Slide Div V1.0 
 * Slide Div eignet sich, um ein <div> Element nach einem Klick auf ein "Trigger-Element" "einzusliden".
 */

if (!window.$wzp) {window.$wzp={}}

/*
 * @param o Options object
 *   trigger: CSS Selector for the trigger element
 *   target: CSS Selector for the sliding element
 *   overlay: CSS Selector for the overlay element. If the element can not be found in the DOM, a div with this id is created
 *   dir: A string to determine the direction from which the element will slide. Either "left" or "right"
 *   id: The id of the article, needed for zpInjectedContent to work (fastInserts)
 */
window.$wzp.slideDiv = function (o){
    if (o.trigger && o.target){
        let trigger = document.querySelector(o.trigger);
        let sliding = document.querySelector(o.target);
        let overlay = document.querySelector(o.overlay);
        
        if (trigger && sliding) {
        
            if (!overlay) {
                overlay = document.createElement('div');
                overlay.id = o.overlay.replace('#', '') || o.trigger.replace('#', '') + '_overlay';
            }
            
            if (o.moveTrigger) {
                trigger.classList.add('zpInjectedContent');
                o.id && trigger.setAttribute('data-item-id', o.id);
                document.body.append(trigger);
            }
            
            overlay.classList.add('zpInjectedContent');
            sliding.classList.add('zpInjectedContent');
            o.id && sliding.setAttribute('data-item-id', o.id);
            o.id && overlay.setAttribute('data-item-id', o.id);
            
            document.body.append(sliding);
            document.body.append(overlay);
            
            function close(){
                sliding.style[o.dir || 'right'] = '-' + o.slideValue;
                sliding.style.opacity = '0';
                sliding.style.visibility = 'hidden';
                overlay.style.visibility = 'hidden';
                overlay.style.opacity = '0';
            }
            
            /* Initially hide the window */
            close();
            
            trigger.addEventListener('click', function (){
                sliding.style[o.dir || 'right'] = "0";
                sliding.style.opacity = '1';
                sliding.style.visibility = 'visible';
                overlay.style.visibility = 'visible';
                overlay.style.opacity = '1';
            });
            
            overlay.addEventListener('click', close);
            
            /* Close the menu when a link is clicked */
            sliding.addEventListener('click', function (e) {
                if (e.target.closest('a')) {
                    close();
                }
            });
            
            const closeBtn = sliding.querySelector('[data-wzp-action="close"]');
            if (closeBtn) {
                closeBtn.addEventListener('click', close);
            }
        }
    }
};